---
sidebar_position: 0
sidebar_label: Roslynator Testing Framework
---

# Roslynator Testing Framework

[Types](#types) &#x2022; [Class Hierarchy](#class-hierarchy)

## Types

* [Roslynator.Testing](../../docs/api/Roslynator/Testing/index.md)
  * [CodeVerifier](../../docs/api/Roslynator/Testing/CodeVerifier/index.md)
  * [CompilerDiagnosticFixTestData](../../docs/api/Roslynator/Testing/CompilerDiagnosticFixTestData/index.md)
  * [CompilerDiagnosticFixVerifier&lt;TFixProvider&gt;](../../docs/api/Roslynator/Testing/CompilerDiagnosticFixVerifier-1/index.md)
  * [DiagnosticTestData](../../docs/api/Roslynator/Testing/DiagnosticTestData/index.md)
  * [DiagnosticVerifier&lt;TAnalyzer, TFixProvider&gt;](../../docs/api/Roslynator/Testing/DiagnosticVerifier-2/index.md)
  * [ExpectedTestState](../../docs/api/Roslynator/Testing/ExpectedTestState/index.md)
  * [RefactoringTestData](../../docs/api/Roslynator/Testing/RefactoringTestData/index.md)
  * [RefactoringVerifier&lt;TRefactoringProvider&gt;](../../docs/api/Roslynator/Testing/RefactoringVerifier-1/index.md)
  * [TestOptions](../../docs/api/Roslynator/Testing/TestOptions/index.md)
  * [AdditionalFile](../../docs/api/Roslynator/Testing/AdditionalFile/index.md)
  * [TestCode](../../docs/api/Roslynator/Testing/TestCode/index.md)
* [Roslynator.Testing.CSharp](../../docs/api/Roslynator/Testing/CSharp/index.md)
  * [CSharpCompilerDiagnosticFixVerifier&lt;TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/CSharpCompilerDiagnosticFixVerifier-1/index.md)
  * [CSharpDiagnosticVerifier&lt;TAnalyzer, TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/CSharpDiagnosticVerifier-2/index.md)
  * [CSharpRefactoringVerifier&lt;TRefactoringProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/CSharpRefactoringVerifier-1/index.md)
  * [CSharpTestOptions](../../docs/api/Roslynator/Testing/CSharp/CSharpTestOptions/index.md)
* [Roslynator.Testing.CSharp.MSTest](../../docs/api/Roslynator/Testing/CSharp/MSTest/index.md)
  * [MSTestCompilerDiagnosticFixVerifier&lt;TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/MSTest/MSTestCompilerDiagnosticFixVerifier-1/index.md)
  * [MSTestDiagnosticVerifier&lt;TAnalyzer, TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/MSTest/MSTestDiagnosticVerifier-2/index.md)
  * [MSTestRefactoringVerifier&lt;TRefactoringProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/MSTest/MSTestRefactoringVerifier-1/index.md)
* [Roslynator.Testing.CSharp.Xunit](../../docs/api/Roslynator/Testing/CSharp/Xunit/index.md)
  * [XunitCompilerDiagnosticFixVerifier&lt;TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/Xunit/XunitCompilerDiagnosticFixVerifier-1/index.md)
  * [XunitDiagnosticVerifier&lt;TAnalyzer, TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/Xunit/XunitDiagnosticVerifier-2/index.md)
  * [XunitRefactoringVerifier&lt;TRefactoringProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/Xunit/XunitRefactoringVerifier-1/index.md)

## Class Hierarchy

* &ensp; \([Object](https://docs.microsoft.com/en-us/dotnet/api/system.object)\)<a id="class-hierarchy-System_Object"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [CodeVerifier](../../docs/api/Roslynator/Testing/CodeVerifier/index.md)<a id="class-hierarchy-Roslynator_Testing_CodeVerifier"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [CompilerDiagnosticFixVerifier&lt;TFixProvider&gt;](../../docs/api/Roslynator/Testing/CompilerDiagnosticFixVerifier-1/index.md)<a id="class-hierarchy-Roslynator_Testing_CompilerDiagnosticFixVerifier_1"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CompilerDiagnosticFixVerifier_1 "CompilerDiagnosticFixVerifier<TFixProvider>") &ensp; [CSharpCompilerDiagnosticFixVerifier&lt;TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/CSharpCompilerDiagnosticFixVerifier-1/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_CSharpCompilerDiagnosticFixVerifier_1"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CompilerDiagnosticFixVerifier_1 "CompilerDiagnosticFixVerifier<TFixProvider>") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CSharp_CSharpCompilerDiagnosticFixVerifier_1 "CSharpCompilerDiagnosticFixVerifier<TFixProvider>") &ensp; [MSTestCompilerDiagnosticFixVerifier&lt;TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/MSTest/MSTestCompilerDiagnosticFixVerifier-1/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_MSTest_MSTestCompilerDiagnosticFixVerifier_1"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CompilerDiagnosticFixVerifier_1 "CompilerDiagnosticFixVerifier<TFixProvider>") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CSharp_CSharpCompilerDiagnosticFixVerifier_1 "CSharpCompilerDiagnosticFixVerifier<TFixProvider>") &ensp; [XunitCompilerDiagnosticFixVerifier&lt;TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/Xunit/XunitCompilerDiagnosticFixVerifier-1/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_Xunit_XunitCompilerDiagnosticFixVerifier_1"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [DiagnosticVerifier&lt;TAnalyzer, TFixProvider&gt;](../../docs/api/Roslynator/Testing/DiagnosticVerifier-2/index.md)<a id="class-hierarchy-Roslynator_Testing_DiagnosticVerifier_2"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_DiagnosticVerifier_2 "DiagnosticVerifier<TAnalyzer, TFixProvider>") &ensp; [CSharpDiagnosticVerifier&lt;TAnalyzer, TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/CSharpDiagnosticVerifier-2/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_CSharpDiagnosticVerifier_2"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_DiagnosticVerifier_2 "DiagnosticVerifier<TAnalyzer, TFixProvider>") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CSharp_CSharpDiagnosticVerifier_2 "CSharpDiagnosticVerifier<TAnalyzer, TFixProvider>") &ensp; [MSTestDiagnosticVerifier&lt;TAnalyzer, TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/MSTest/MSTestDiagnosticVerifier-2/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_MSTest_MSTestDiagnosticVerifier_2"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_DiagnosticVerifier_2 "DiagnosticVerifier<TAnalyzer, TFixProvider>") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CSharp_CSharpDiagnosticVerifier_2 "CSharpDiagnosticVerifier<TAnalyzer, TFixProvider>") &ensp; [XunitDiagnosticVerifier&lt;TAnalyzer, TFixProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/Xunit/XunitDiagnosticVerifier-2/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_Xunit_XunitDiagnosticVerifier_2"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [RefactoringVerifier&lt;TRefactoringProvider&gt;](../../docs/api/Roslynator/Testing/RefactoringVerifier-1/index.md)<a id="class-hierarchy-Roslynator_Testing_RefactoringVerifier_1"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_RefactoringVerifier_1 "RefactoringVerifier<TRefactoringProvider>") &ensp; [CSharpRefactoringVerifier&lt;TRefactoringProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/CSharpRefactoringVerifier-1/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_CSharpRefactoringVerifier_1"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_RefactoringVerifier_1 "RefactoringVerifier<TRefactoringProvider>") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CSharp_CSharpRefactoringVerifier_1 "CSharpRefactoringVerifier<TRefactoringProvider>") &ensp; [MSTestRefactoringVerifier&lt;TRefactoringProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/MSTest/MSTestRefactoringVerifier-1/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_MSTest_MSTestRefactoringVerifier_1"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CodeVerifier "CodeVerifier") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_RefactoringVerifier_1 "RefactoringVerifier<TRefactoringProvider>") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_CSharp_CSharpRefactoringVerifier_1 "CSharpRefactoringVerifier<TRefactoringProvider>") &ensp; [XunitRefactoringVerifier&lt;TRefactoringProvider&gt;](../../docs/api/Roslynator/Testing/CSharp/Xunit/XunitRefactoringVerifier-1/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_Xunit_XunitRefactoringVerifier_1"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [CompilerDiagnosticFixTestData](../../docs/api/Roslynator/Testing/CompilerDiagnosticFixTestData/index.md)<a id="class-hierarchy-Roslynator_Testing_CompilerDiagnosticFixTestData"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [DiagnosticTestData](../../docs/api/Roslynator/Testing/DiagnosticTestData/index.md)<a id="class-hierarchy-Roslynator_Testing_DiagnosticTestData"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [ExpectedTestState](../../docs/api/Roslynator/Testing/ExpectedTestState/index.md)<a id="class-hierarchy-Roslynator_Testing_ExpectedTestState"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [RefactoringTestData](../../docs/api/Roslynator/Testing/RefactoringTestData/index.md)<a id="class-hierarchy-Roslynator_Testing_RefactoringTestData"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [TestOptions](../../docs/api/Roslynator/Testing/TestOptions/index.md)<a id="class-hierarchy-Roslynator_Testing_TestOptions"></a>
* &ensp; [&bull;](#class-hierarchy-System_Object "Object") &ensp; [&bull;](#class-hierarchy-Roslynator_Testing_TestOptions "TestOptions") &ensp; [CSharpTestOptions](../../docs/api/Roslynator/Testing/CSharp/CSharpTestOptions/index.md)<a id="class-hierarchy-Roslynator_Testing_CSharp_CSharpTestOptions"></a>

